import webbrowser
from Modules.submenu import build_submenu
from Modules.Imports.ttp_imports import *

def analysis_ip_submenu():
    """
    Submenu for IP analysis resources and tools.
    """
    actions = {
        "1": {"description": "Open Censys", "function": open_censys},
        "2": {"description": "Open Shodan", "function": open_shodan},
        "3": {"description": "Open Feodo Tracker", "function": open_feodo},
        "4": {"description": "Open IBM X-Force", "function": open_ibm_xforce},
        "5": {"description": "Open Greynoise", "function": open_greynoise},
        "6": {"description": "Open IP Void", "function": open_ipvoid},
        "7": {"description": "Open URL Scan", "function": open_urlscan},
        "8": {"description": "Open VirusTotal", "function": open_virustotal},
        "9": {"description": "Open DNS Dumpster", "function": open_dnsdumpster},
        "10": {"description": "Open BGP Tools", "function": open_bgptools},
    }
    build_submenu("IP Analysis Resources", actions)

# Functions to open each resource in the default web browser
def open_censys():
    webbrowser.open("https://search.censys.io/")
    print("Opening Censys in your browser...")

def open_shodan():
    webbrowser.open("https://www.shodan.io/")
    print("Opening Shodan in your browser...")

def open_feodo():
    webbrowser.open("https://feodotracker.abuse.ch/browse/")
    print("Opening Feodo Tracker in your browser...")

def open_ibm_xforce():
    webbrowser.open("https://exchange.xforce.ibmcloud.com/")
    print("Opening IBM X-Force in your browser...")

def open_greynoise():
    webbrowser.open("https://viz.greynoise.io/")
    print("Opening Greynoise in your browser...")

def open_ipvoid():
    webbrowser.open("https://www.ipvoid.com/")
    print("Opening IP Void in your browser...")

def open_urlscan():
    webbrowser.open("https://urlscan.io/")
    print("Opening URL Scan in your browser...")

def open_virustotal():
    webbrowser.open("https://www.virustotal.com/gui/")
    print("Opening VirusTotal in your browser...")

def open_dnsdumpster():
    webbrowser.open("https://dnsdumpster.com/")
    print("Opening DNS Dumpster in your browser...")

def open_bgptools():
    webbrowser.open("https://bgp.tools/")
    print("Opening BGP Tools in your browser...")