import webbrowser
from Modules.submenu import build_submenu

def analysis_threat_submenu():
    """
    Submenu for threat intelligence tools and resources.
    """
    actions = {
        "1": {"description": "Threat Intel - MyDFIR (YouTube)", "function": open_mydfir},
        "2": {"description": "Threat View", "function": open_threatview},
        "3": {"description": "Threat Miner", "function": open_threatminer},
        "4": {"description": "Pulsedive", "function": open_pulsedive},
        "5": {"description": "OTX Alienvault", "function": open_otx_alienvault},
        "6": {"description": "Pyramid of Pain", "function": open_pyramid_of_pain},
    }
    build_submenu("Threat Intelligence Resources", actions)

# Functions to open each link
def open_mydfir():
    """
    Open Threat Intel - MyDFIR YouTube video.
    """
    url = "https://youtu.be/PyWKOG3q4P4?si=eh4Dl_40ZscQa9n8"
    webbrowser.open(url)
    print(f"Opening: {url}")

def open_threatview():
    """
    Open Threat View website.
    """
    url = "https://threatview.io/"
    webbrowser.open(url)
    print(f"Opening: {url}")

def open_threatminer():
    """
    Open Threat Miner website.
    """
    url = "https://www.threatminer.org/index.php"
    webbrowser.open(url)
    print(f"Opening: {url}")

def open_pulsedive():
    """
    Open Pulsedive website.
    """
    url = "https://pulsedive.com/"
    webbrowser.open(url)
    print(f"Opening: {url}")

def open_otx_alienvault():
    """
    Open OTX Alienvault website.
    """
    url = "https://otx.alienvault.com/"
    webbrowser.open(url)
    print(f"Opening: {url}")

def open_pyramid_of_pain():
    """
    Open Pyramid of Pain resource.
    """
    url = "https://detect-respond.blogspot.com/2013/03/the-pyramid-of-pain.html"
    webbrowser.open(url)
    print(f"Opening: {url}")
