import webbrowser
from Modules.submenu import build_submenu

def analysis_malware_submenu():
    """
    Submenu for malware analysis tools and resources.
    """
    actions = {
        "1": {"description": "Virus Total", "function": open_virus_total},
        "2": {"description": "INTEZER", "function": open_intezer},
        "3": {"description": "Any Run", "function": open_any_run},
        "4": {"description": "Joe Security", "function": open_joe_security},
        "5": {"description": "Hybrid Analysis", "function": open_hybrid_analysis},
        "6": {"description": "OTX Alienvault", "function": open_otx_alienvault},
    }
    build_submenu("Malware Analysis Tools", actions)

# Functions to open each link
def open_virus_total():
    """
    Open Virus Total website.
    """
    url = "https://www.virustotal.com/gui/home/upload"
    webbrowser.open(url)
    print(f"Opening: {url}")

def open_intezer():
    """
    Open Intezer website.
    """
    url = "https://analyze.intezer.com/"
    webbrowser.open(url)
    print(f"Opening: {url}")

def open_any_run():
    """
    Open Any Run website.
    """
    url = "https://any.run/"
    webbrowser.open(url)
    print(f"Opening: {url}")

def open_joe_security():
    """
    Open Joe Security website.
    """
    url = "https://www.joesecurity.org/"
    webbrowser.open(url)
    print(f"Opening: {url}")

def open_hybrid_analysis():
    """
    Open Hybrid Analysis website.
    """
    url = "https://www.hybrid-analysis.com/"
    webbrowser.open(url)
    print(f"Opening: {url}")

def open_otx_alienvault():
    """
    Open OTX Alienvault website.
    """
    url = "https://otx.alienvault.com/"
    webbrowser.open(url)
    print(f"Opening: {url}")
